using C969Project.Data;
using C969Project.Data.Models;

namespace C969Project;

public partial class RecordsForm : Form
{
    private List<Customer>? _customers;
    private AddUpdateCustomerForm _form = new(); 
    
    public RecordsForm()
    {
        InitializeComponent();
        UpdateCustomersList();

        AddButton.Click += (sender, args) =>
        {
            _form.InitAdd();
            _form.Closed += (o, args2) => { UpdateCustomersList(); };
        };
        
        ModifyButton.Click += (sender, args) =>
        {
            var selectedCustomer = _customers[CustomersDataGrid.CurrentCell.RowIndex];
            _form.InitUpdate(selectedCustomer);
            _form.Closed += (o, args2) => { UpdateCustomersList(); };
        };

        DeleteButton.Click += (sender, args) =>
        {
            var selectedCustomer = _customers[CustomersDataGrid.CurrentCell.RowIndex];
            var result = MessageBox.Show("Are you sure you want to delete this record?", "Delete Record", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (result == DialogResult.OK)
            {
                _customers.Remove(selectedCustomer);
                DatabaseHelper.DeleteCustomer(selectedCustomer);
                UpdateCustomersList();
            }
        };
    }
    
    

    public void UpdateCustomersList()
    {
        if (_customers != null && _customers.Count > 0) _customers.Clear(); 
        _customers = DatabaseHelper.RetrieveCustomers();
        CustomersDataGrid.DataSource = _customers;
    }
}